VERSION 5.00
Begin VB.UserControl Panel3D 
   AutoRedraw      =   -1  'True
   CanGetFocus     =   0   'False
   ClientHeight    =   3495
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4695
   ControlContainer=   -1  'True
   MaskColor       =   &H00FF00FF&
   PropertyPages   =   "ctrlPanel3D.ctx":0000
   ScaleHeight     =   233
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   313
   ToolboxBitmap   =   "ctrlPanel3D.ctx":0051
End
Attribute VB_Name = "Panel3D"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "PropPageWizardRun" ,"Yes"
Option Explicit

Private Const ErrMsg As String = "Error property!"
Dim Busy As Boolean

Public Enum p3dFont3DFX
  p3dNo3D = 0
  p3dInsetLight = -1
  p3dInsetHard = -2
  p3dRaisedLight = 1
  p3dRaisedHard = 2
End Enum

Public Enum p3dTitleBarStyle
  p3dNone = 0
  p3dVertLines = 1
  p3dHorzLines = 2
  p3dInsideLines = 3
  p3dOutsideLines = 4
End Enum

Public Enum p3dTextAlignmentHorz
  p3dNoAlignH = 0
  p3dAlignLeft = 1
  p3dAlignCenter = 2
  p3dAlignRight = 3
  p3dAlignJustify = 4
  p3dAlignFullH = 9
End Enum
Public Enum p3dTextAlignmentVert
  p3dNoAlignV = 0
  p3dAlignTop = 1
  p3dAlignMiddle = 2
  p3dAlignBottom = 3
  p3dAlignFullV = 9
End Enum
Public Enum p3dWordWrapStyle
  p3dNoWrap = 0
  p3dNormalWrap = 1
  p3dForceWrap = 2
End Enum

Public Enum p3dBevelType
  p3dNoBevel = 0
  p3dFixedShadow = 1
  p3dFixedLight = 2
  p3dInset = 3
  p3dRaised = 4
End Enum

'Property:
'----------------------------------------------------------------
  'Begin property: Special
  Dim prpForeColor As OLE_COLOR
  'End Special
'----------------------------------------------------------------
  'Begin property: Appearance
  Const p3dBevelInner As Integer = p3dBevelType.p3dNoBevel, p3dBevelOuter As Integer = p3dBevelType.p3dRaised
  Dim prpBevelInner As p3dBevelType, prpBevelOuter As p3dBevelType
  Const p3dBevelWidth As Integer = 1, p3dBorderWidth As Integer = 1
  Dim prpBevelWidth As Integer, prpBorderWidth As Integer
  Const p3dColor3DFace = vb3DFace, p3dColor3DLight = vb3DHighlight, p3dColor3DShadow = vb3DShadow
  Dim prpColor3DFace As OLE_COLOR, prpColor3DLight As OLE_COLOR, prpColor3DShadow As OLE_COLOR
  Dim prpAutoColor3D As Boolean
  Const p3dOutline = False
  Dim prpOutline As Boolean
  Const p3dRound = 0
  Dim prpRound As Integer
  'End Appearance
'----------------------------------------------------------------
  'Begin property: TitleBar
  Const p3dTitleBar As Integer = p3dTitleBarStyle.p3dNone
  Dim prpTitleBar As p3dTitleBarStyle
  Const p3dUse3DLine As Boolean = True
  Dim prpUse3DLine As Boolean
  Const p3dFieldV As Integer = 1, p3dFieldE As Integer = 2, p3dFieldI As Integer = 2
  Dim prpFieldV As Integer, prpFieldE As Integer, prpFieldI As Integer
  'End property
'----------------------------------------------------------------
  'Begin property: Text
  Const p3dText As Variant = Null
  Dim prpText As Variant
  Const p3dWordWrap = p3dWordWrapStyle.p3dNormalWrap
  Dim prpWordWrap As p3dWordWrapStyle
  Const p3dFont3D As Integer = p3dFont3DFX.p3dNo3D
  Dim prpFont3D As p3dFont3DFX
  Const p3dAlignmentH As Integer = p3dTextAlignmentHorz.p3dAlignCenter, p3dAlignmentV As Integer = p3dTextAlignmentVert.p3dAlignMiddle
  Dim prpAlignmentH As p3dTextAlignmentHorz, prpAlignmentV As p3dTextAlignmentVert
  'End property
'----------------------------------------------------------------
'End Property

'Event Declarations:
Event TitleClick()
Attribute TitleClick.VB_Description = "Occurs when the user presses and then releases a mouse button over an title of panel. Order: TitleClick, Click."
Event Click() 'MappingInfo=UserControl,UserControl,-1,Click
Attribute Click.VB_Description = "Occurs when the user presses and then releases a mouse button over an object."
Event DblClick() 'MappingInfo=UserControl,UserControl,-1,DblClick
Attribute DblClick.VB_Description = "Occurs when the user presses and releases a mouse button and then presses and releases it again over an object."
Event MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single) 'MappingInfo=UserControl,UserControl,-1,MouseDown
Attribute MouseDown.VB_Description = "Occurs when the user presses the mouse button while an object has the focus."
Event MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single) 'MappingInfo=UserControl,UserControl,-1,MouseMove
Attribute MouseMove.VB_Description = "Occurs when the user moves the mouse."
Event MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single) 'MappingInfo=UserControl,UserControl,-1,MouseUp
Attribute MouseUp.VB_Description = "Occurs when the user releases the mouse button while an object has the focus."

Public Sub About_Panel3D()
Attribute About_Panel3D.VB_Description = "About control."
Attribute About_Panel3D.VB_UserMemId = -552
Attribute About_Panel3D.VB_MemberFlags = "40"
  aboutPanel3D.Show vbModal
  Unload aboutPanel3D
  Set aboutPanel3D = Nothing
End Sub

'START User subs
Sub Paint_Me()
Attribute Paint_Me.VB_Description = "Internal procedure. Drawing control."
Attribute Paint_Me.VB_UserMemId = -550
Attribute Paint_Me.VB_MemberFlags = "40"
If Busy Then Exit Sub
UserControl.Cls
Paint_Text
Paint_Border
Paint_Outline
End Sub

Sub Paint_Outline()
Attribute Paint_Outline.VB_Description = "Internal procedure. Drawing outline."
Attribute Paint_Outline.VB_MemberFlags = "40"
Dim X1 As Single, Y1 As Single, X2 As Single, Y2 As Single
Dim PX As Single, PY As Single, C As Long
Const pi = 3.14159265358979
C = vbWindowFrame
With UserControl
  PX = .ScaleX(1, vbPixels, .ScaleMode)
  PY = .ScaleY(1, vbPixels, .ScaleMode)
  X1 = .ScaleLeft
  Y1 = .ScaleTop
  X2 = X1 + .ScaleWidth - PX
  Y2 = Y1 + .ScaleHeight - PY
End With
If Not prpOutline Then
  Exit Sub
End If
Select Case prpRound
  Case 0
    UserControl.Line (X1, Y1)-(X2, Y2), C, B
  Case 1
    UserControl.Line (X1 + PX, Y1)-(X2, Y1), C
    UserControl.Line (X2, Y1 + PY)-(X2, Y2), C
    UserControl.Line (X2 - PX, Y2)-(X1, Y2), C
    UserControl.Line (X1, Y2 - PY)-(X1, Y1), C
  Case Else
    UserControl.Line (X1 + PX * (prpRound), Y1)-(X2 - PX * (prpRound - 1), Y1), C
    UserControl.Line (X2, Y1 + PY * (prpRound))-(X2, Y2 - PY * (prpRound - 1)), C
    UserControl.Line (X2 - PX * (prpRound), Y2)-(X1 + PX * (prpRound - 2), Y2), C
    UserControl.Line (X1, Y2 - PY * (prpRound))-(X1, Y1 + PY * (prpRound - 2)), C
    UserControl.Circle (X1 + PX * prpRound, Y1 + PY * prpRound), prpRound, C, 0.5 * pi, pi
    UserControl.Circle (X1 + PX * prpRound, Y2 - PY * prpRound), prpRound, C, pi, 1.5 * pi
    UserControl.Circle (X2 - PX * prpRound, Y2 - PY * prpRound), prpRound, C, 1.5 * pi, 0
    UserControl.Circle (X2 - PX * prpRound, Y1 + PY * prpRound), prpRound, C, 0, 0.5 * pi
End Select
End Sub
Sub Paint_Border()
Attribute Paint_Border.VB_Description = "Internal procedure. Drawing edges."
Attribute Paint_Border.VB_MemberFlags = "40"
Dim X1 As Single, Y1 As Single, X2 As Single, Y2 As Single
Dim PX As Single, PY As Single, R As Single, I As Integer, I0 As Integer
Dim C1 As Long, C2 As Long
Const pi = 3.14159265358979
With UserControl
  PX = .ScaleX(1, vbPixels, .ScaleMode)
  PY = .ScaleY(1, vbPixels, .ScaleMode)
  X1 = .ScaleLeft
  Y1 = .ScaleTop
  X2 = X1 + .ScaleWidth - PX
  Y2 = Y1 + .ScaleHeight - PY
End With
If prpOutline Then
  X1 = X1 + PX
  X2 = X2 - PX
  Y1 = Y1 + PY
  Y2 = Y2 - PY
End If
For I = 0 To prpBevelWidth - 1
  I0 = I
  R = prpRound - I0: If R < 0 Then R = 0
  Select Case R
    Case 0
      Select Case prpBevelOuter
        Case p3dNoBevel
        Case p3dFixedShadow
          C1 = prpColor3DShadow
          C2 = prpColor3DShadow
        Case p3dFixedLight
          C1 = prpColor3DLight
          C2 = prpColor3DLight
        Case p3dInset
          C2 = prpColor3DLight
          C1 = prpColor3DShadow
        Case p3dRaised
          C1 = prpColor3DLight
          C2 = prpColor3DShadow
      End Select
      If prpBevelOuter <> p3dNoBevel Then
        UserControl.Line (X1 + PX * I0, Y2 - PY * I0)-(X1 + PX * I0, Y1 + PY * I0), C1
        UserControl.Line (X1 + PX * I0, Y1 + PY * I0)-(X2 - PX * I0, Y1 + PY * I0), C1
        UserControl.Line (X2 - PX * I0, Y1 + PY * I0)-(X2 - PX * I0, Y2 - PY * I0), C2
        UserControl.Line (X2 - PX * I0, Y2 - PY * I0)-(X1 + PX * I0, Y2 - PY * I0), C2
      End If
    Case 1
      Select Case prpBevelOuter
        Case p3dNoBevel
        Case p3dFixedShadow
          C1 = prpColor3DShadow
          C2 = prpColor3DShadow
        Case p3dFixedLight
          C1 = prpColor3DLight
          C2 = prpColor3DLight
        Case p3dInset
          C2 = prpColor3DLight
          C1 = prpColor3DShadow
        Case p3dRaised
          C1 = prpColor3DLight
          C2 = prpColor3DShadow
      End Select
      If prpBevelOuter <> p3dNoBevel Then
        UserControl.Line (X1 + PX * I0, Y2 - PY * I0)-(X1 + PX * I0, Y1 + PY * I0), C1
        UserControl.Line (X1 + PX * I0, Y1 + PY * I0)-(X2 - PX * I0, Y1 + PY * I0), C1
        UserControl.Line (X2 - PX * I0, Y1 + PY * I0)-(X2 - PX * I0, Y2 - PY * I0), C2
        UserControl.Line (X2 - PX * I0, Y2 - PY * I0)-(X1 + PX * I0, Y2 - PY * I0), C2
      End If
    Case Else
      Select Case prpBevelOuter
        Case p3dNoBevel
        Case p3dFixedShadow
          C1 = prpColor3DShadow
          C2 = prpColor3DShadow
        Case p3dFixedLight
          C1 = prpColor3DLight
          C2 = prpColor3DLight
        Case p3dInset
          C2 = prpColor3DLight
          C1 = prpColor3DShadow
        Case p3dRaised
          C1 = prpColor3DLight
          C2 = prpColor3DShadow
      End Select
      If prpBevelOuter <> p3dNoBevel Then
        UserControl.Line (X1 + PX * I0, Y2 - PY * (I0 + R))-(X1 + PX * I0, Y1 + PY * (I0 + R - 2)), C1
        UserControl.Line (X1 + PX * (I0 + R), Y1 + PY * I0)-(X2 - PX * (I0 + R - 2), Y1 + PY * I0), C1
        UserControl.Line (X2 - PX * I0, Y1 + PY * (I0 + R))-(X2 - PX * I0, Y2 - PY * (I0 + R - 2)), C2
        UserControl.Line (X2 - PX * (I0 + R), Y2 - PY * I0)-(X1 + PX * (I0 + R - 2), Y2 - PY * I0), C2
        UserControl.Circle (X1 + PX * (I0 + R), Y1 + PY * (I0 + R)), R, C1, 0.5 * pi, pi
        UserControl.Circle (X2 - PX * (I0 + R), Y2 - PY * (I0 + R)), R, C2, 1.5 * pi, 0
        UserControl.Circle (X1 + PX * (I0 + R), Y2 - PY * (I0 + R)), R, C1, pi, 1.25 * pi
        UserControl.Circle (X1 + PX * (I0 + R), Y2 - PY * (I0 + R)), R, C2, 1.25 * pi, 1.5 * pi
        UserControl.Circle (X2 - PX * (I0 + R), Y1 + PY * (I0 + R)), R, C2, 0, 0.25 * pi
        UserControl.Circle (X2 - PX * (I0 + R), Y1 + PY * (I0 + R)), R, C1, 0.25 * pi, 0.5 * pi
      End If
  End Select
  I0 = I + prpBevelWidth + prpBorderWidth
  R = prpRound - I0: If R < 0 Then R = 0
  Select Case R
    Case 0
      Select Case prpBevelInner
        Case p3dNoBevel
        Case p3dFixedShadow
          C1 = prpColor3DShadow
          C2 = prpColor3DShadow
        Case p3dFixedLight
          C1 = prpColor3DLight
          C2 = prpColor3DLight
        Case p3dInset
          C2 = prpColor3DLight
          C1 = prpColor3DShadow
        Case p3dRaised
          C1 = prpColor3DLight
          C2 = prpColor3DShadow
      End Select
      If prpBevelInner <> p3dNoBevel Then
        UserControl.Line (X1 + PX * I0, Y2 - PY * I0)-(X1 + PX * I0, Y1 + PY * I0), C1
        UserControl.Line (X1 + PX * I0, Y1 + PY * I0)-(X2 - PX * I0, Y1 + PY * I0), C1
        UserControl.Line (X2 - PX * I0, Y1 + PY * I0)-(X2 - PX * I0, Y2 - PY * I0), C2
        UserControl.Line (X2 - PX * I0, Y2 - PY * I0)-(X1 + PX * I0, Y2 - PY * I0), C2
      End If
    Case 1
      Select Case prpBevelInner
        Case p3dNoBevel
        Case p3dFixedShadow
          C1 = prpColor3DShadow
          C2 = prpColor3DShadow
        Case p3dFixedLight
          C1 = prpColor3DLight
          C2 = prpColor3DLight
        Case p3dInset
          C2 = prpColor3DLight
          C1 = prpColor3DShadow
        Case p3dRaised
          C1 = prpColor3DLight
          C2 = prpColor3DShadow
      End Select
      If prpBevelInner <> p3dNoBevel Then
        UserControl.Line (X1 + PX * I0, Y2 - PY * I0)-(X1 + PX * I0, Y1 + PY * I0), C1
        UserControl.Line (X1 + PX * I0, Y1 + PY * I0)-(X2 - PX * I0, Y1 + PY * I0), C1
        UserControl.Line (X2 - PX * I0, Y1 + PY * I0)-(X2 - PX * I0, Y2 - PY * I0), C2
        UserControl.Line (X2 - PX * I0, Y2 - PY * I0)-(X1 + PX * I0, Y2 - PY * I0), C2
      End If
    Case Else
      Select Case prpBevelInner
        Case p3dNoBevel
        Case p3dFixedShadow
          C1 = prpColor3DShadow
          C2 = prpColor3DShadow
        Case p3dFixedLight
          C1 = prpColor3DLight
          C2 = prpColor3DLight
        Case p3dInset
          C2 = prpColor3DLight
          C1 = prpColor3DShadow
        Case p3dRaised
          C1 = prpColor3DLight
          C2 = prpColor3DShadow
      End Select
      If prpBevelInner <> p3dNoBevel Then
        UserControl.Line (X1 + PX * I0, Y2 - PY * (I0 + R))-(X1 + PX * I0, Y1 + PY * (I0 + R - 2)), C1
        UserControl.Line (X1 + PX * (I0 + R), Y1 + PY * I0)-(X2 - PX * (I0 + R - 2), Y1 + PY * I0), C1
        UserControl.Line (X2 - PX * I0, Y1 + PY * (I0 + R))-(X2 - PX * I0, Y2 - PY * (I0 + R - 2)), C2
        UserControl.Line (X2 - PX * (I0 + R), Y2 - PY * I0)-(X1 + PX * (I0 + R - 2), Y2 - PY * I0), C2
        UserControl.Circle (X1 + PX * (I0 + R), Y1 + PY * (I0 + R)), R, C1, 0.5 * pi, pi
        UserControl.Circle (X2 - PX * (I0 + R), Y2 - PY * (I0 + R)), R, C2, 1.5 * pi, 0
        UserControl.Circle (X1 + PX * (I0 + R), Y2 - PY * (I0 + R)), R, C1, pi, 1.25 * pi
        UserControl.Circle (X1 + PX * (I0 + R), Y2 - PY * (I0 + R)), R, C2, 1.25 * pi, 1.5 * pi
        UserControl.Circle (X2 - PX * (I0 + R), Y1 + PY * (I0 + R)), R, C2, 0, 0.25 * pi
        UserControl.Circle (X2 - PX * (I0 + R), Y1 + PY * (I0 + R)), R, C1, 0.25 * pi, 0.5 * pi
      End If
  End Select
Next I
For I = 0 To prpBorderWidth - 1
  I0 = I + prpBevelWidth
  R = prpRound - I0: If R < 0 Then R = 0
  Select Case R
    Case 0
      If prpBevelInner <> p3dNoBevel And prpBevelOuter <> p3dNoBevel Then
        UserControl.Line (X1 + PX * I0, Y2 - PY * I0)-(X1 + PX * I0, Y1 + PY * I0), prpColor3DFace
        UserControl.Line (X1 + PX * I0, Y1 + PY * I0)-(X2 - PX * I0, Y1 + PY * I0), prpColor3DFace
        UserControl.Line (X2 - PX * I0, Y1 + PY * I0)-(X2 - PX * I0, Y2 - PY * I0), prpColor3DFace
        UserControl.Line (X2 - PX * I0, Y2 - PY * I0)-(X1 + PX * I0, Y2 - PY * I0), prpColor3DFace
      End If
    Case 1
      If prpBevelInner <> p3dNoBevel And prpBevelOuter <> p3dNoBevel Then
        UserControl.Line (X1 + PX * I0, Y2 - PY * I0)-(X1 + PX * I0, Y1 + PY * I0), prpColor3DFace
        UserControl.Line (X1 + PX * I0, Y1 + PY * I0)-(X2 - PX * I0, Y1 + PY * I0), prpColor3DFace
        UserControl.Line (X2 - PX * I0, Y1 + PY * I0)-(X2 - PX * I0, Y2 - PY * I0), prpColor3DFace
        UserControl.Line (X2 - PX * I0, Y2 - PY * I0)-(X1 + PX * I0, Y2 - PY * I0), prpColor3DFace
      End If
    Case Else
      If prpBevelInner <> p3dNoBevel And prpBevelOuter <> p3dNoBevel Then
        UserControl.Line (X1 + PX * I0, Y2 - PY * (I0 + R))-(X1 + PX * I0, Y1 + PY * (I0 + R - 2)), prpColor3DFace
        UserControl.Line (X1 + PX * (I0 + R), Y1 + PY * I0)-(X2 - PX * (I0 + R - 2), Y1 + PY * I0), prpColor3DFace
        UserControl.Line (X2 - PX * I0, Y1 + PY * (I0 + R))-(X2 - PX * I0, Y2 - PY * (I0 + R - 2)), prpColor3DFace
        UserControl.Line (X2 - PX * (I0 + R), Y2 - PY * I0)-(X1 + PX * (I0 + R - 2), Y2 - PY * I0), prpColor3DFace
        UserControl.Circle (X1 + PX * (I0 + R), Y1 + PY * (I0 + R)), R, prpColor3DFace, 0.5 * pi, pi
        UserControl.Circle (X2 - PX * (I0 + R), Y2 - PY * (I0 + R)), R, prpColor3DFace, 1.5 * pi, 0
        UserControl.Circle (X1 + PX * (I0 + R), Y2 - PY * (I0 + R)), R, prpColor3DFace, pi, 1.5 * pi
        UserControl.Circle (X2 - PX * (I0 + R), Y1 + PY * (I0 + R)), R, prpColor3DFace, 0, 0.5 * pi
      End If
  End Select
Next I
End Sub
Sub Paint_Text()
Attribute Paint_Text.VB_Description = "Internal procedure. Printing text."
Attribute Paint_Text.VB_MemberFlags = "40"
Dim X1 As Single, Y1 As Single, X2 As Single, Y2 As Single
Dim PX As Single, PY As Single, P As Integer, C As Integer, N As Integer, I As Integer
Dim X As Single, Y As Single, DX As Single, DY As Single
Dim W As Single, H As Single, T As String, Z As String, S As String
Dim TW As Single, TH As Single, MaxW As Single
Const WS As String = " -.,:;!?"
With UserControl
  PX = .ScaleX(1, vbPixels, .ScaleMode)
  PY = .ScaleY(1, vbPixels, .ScaleMode)
End With
Z = ""
Select Case VarType(prpText)
  Case vbEmpty     '0  - Empty (uninitialized)
    Z = ""
  Case vbNull      '1  - Null (no valid data)
    Z = ""
  Case vbInteger   '2  - Integer
    Z = Str$(Trim$(prpText))
  Case vbLong      '3  - Long integer
    Z = Str$(Trim$(prpText))
  Case vbSingle    '4  - Single-precision floating-point number
    Z = Str$(Trim$(Abs(prpText)))
    If Left$(Z, 1) = "." Then Z = "0" + Z
    If Right$(Z, 1) = "." Then Z = Z + "0"
    If prpText < 0 Then Z = "-" + Z
  Case vbDouble    '5  - Double-precision floating-point number
    Z = Str$(Trim$(Abs(prpText)))
    If Left$(Z, 1) = "." Then Z = "0" + Z
    If Right$(Z, 1) = "." Then Z = Z + "0"
    If prpText < 0 Then Z = "-" + Z
  Case vbCurrency  '6  - Currency value
    Z = Format$(prpText, "0.00")
  Case vbDate      '7  - Date value
    Z = Format$(prpText, "DD.MM.YYYY")
  Case vbString    '8  - String
    Z = prpText
  Case vbObject    '9  - Object
    Z = prpText
  Case vbError     '10 - Error value
    Z = "ERROR: " & Trim$(Str$(prpText.Number)) & " - " & prpText.Description & " (" & prpText.Source & ")"
  Case vbBoolean   '11 - Boolean value
    If prpText Then Z = "True" Else Z = "False"
  Case vbVariant   '12 - Variant (used only with arrays of variants)
  Case vbDataObject '13- A data access object
  Case vbDecimal   '14 - Decimal value
    Z = CStr(prpText)
  Case vbByte      '17 - Byte value
    Z = Str$(Trim$(prpText))
    If Len(Z) < 3 Then Z = String$(3 - Len(Z), "0") + Z
  Case vbArray     '8192 - Array
    Z = Format$(prpText(LBound(prpText)))
    For I = LBound(prpText) + 1 To UBound(prpText)
      Z = Z & vbCrLf & Format$(prpText(I))
    Next I
End Select
With UserControl
  X1 = .ScaleLeft
  Y1 = .ScaleTop
  X2 = X1 + .ScaleWidth - PX
  Y2 = Y1 + .ScaleHeight - PY
End With
X1 = X1 + PX: X2 = X2 - PX
Y1 = Y1 + PY: Y2 = Y2 - PY
If prpOutline Then
  X1 = X1 + PX: X2 = X2 - PX
  Y1 = Y1 + PY: Y2 = Y2 - PY
End If
If prpBevelOuter <> p3dNoBevel Then
  X1 = X1 + prpBevelWidth * PX: X2 = X2 - prpBevelWidth * PX
  Y1 = Y1 + prpBevelWidth * PY: Y2 = Y2 - prpBevelWidth * PY
End If
If prpBevelInner <> p3dNoBevel Then
  X1 = X1 + prpBevelWidth * PX: X2 = X2 - prpBevelWidth * PX
  Y1 = Y1 + prpBevelWidth * PY: Y2 = Y2 - prpBevelWidth * PY
End If
If prpBevelInner <> p3dNoBevel And prpBevelInner <> p3dNoBevel Then
  X1 = X1 + prpBorderWidth * PX: X2 = X2 - prpBorderWidth * PX
  Y1 = Y1 + prpBorderWidth * PY: Y2 = Y2 - prpBorderWidth * PY
End If
If Len(Z) > 0 Then
  T = ""
  N = Delimit(0, Z, vbCrLf)
  Select Case prpWordWrap
    Case p3dWordWrapStyle.p3dNoWrap
      For C = 1 To N
        S = Delimit(C, Z, vbCrLf)
        If C > 1 Then T = T + vbCrLf
        T = T + S
      Next C
    Case p3dWordWrapStyle.p3dNormalWrap
      For C = 1 To N
        S = Delimit(C, Z, vbCrLf)
        I = 1: P = 0
        Do
          W = UserControl.TextWidth(S)
          If W <= (X2 - X1) Then Exit Do
          If S = "" Then Exit Do
          If InStr(1, WS, Mid$(S, I, 1)) > 0 Then P = I
          If P > 0 Then
            W = UserControl.TextWidth(Left$(S, P - 1))
            If W > (X2 - X1) Then
              T = T + Left$(S, P - 1) + vbCrLf
              S = LTrim$(Mid$(S, P))
              I = 1: P = 0
            End If
          End If
          If I + 1 > Len(S) Then Exit Do
          I = I + 1
        Loop
        T = T + S
        If C > 1 Then T = T + vbCrLf
      Next C
    Case p3dWordWrapStyle.p3dForceWrap
      For C = 1 To N
        S = Delimit(C, Z, vbCrLf)
        I = 1
        Do
          W = UserControl.TextWidth(S)
          If W <= (X2 - X1) Then Exit Do
          If S = "" Then Exit Do
          If I > 0 Then
            W = UserControl.TextWidth(Left$(S, I - 1))
            If W > (X2 - X1) Then
              T = T + Left$(S, I - 1) + vbCrLf
              S = LTrim$(Mid$(S, I))
              I = 1
            End If
          End If
          If I + 1 > Len(S) Then Exit Do
          I = I + 1
        Loop
        T = T + S
        If C > 1 Then T = T + vbCrLf
      Next C
  End Select
  W = UserControl.TextWidth(T)
  H = UserControl.TextHeight(T)
  Y = Y1: X = X1: DY = 1: DX = 1
  TW = 0: TH = 0
  Select Case prpAlignmentV
    Case p3dTextAlignmentVert.p3dNoAlignV
    Case p3dTextAlignmentVert.p3dAlignTop
      Y = Y1
    Case p3dTextAlignmentVert.p3dAlignMiddle
      Y = (Y1 + Y2 - H) / 2
    Case p3dTextAlignmentVert.p3dAlignBottom
      Y = Y2 - H
    Case p3dTextAlignmentVert.p3dAlignFullV
      If H > 0 Then DY = (Y2 - Y1) / H
  End Select
  Y1 = Y 'TextBox Y1
  N = Delimit(0, T, vbCrLf)
  TH = UserControl.TextHeight(T)
  For I = 1 To N
    Z = Delimit(I, T, vbCrLf)
    W = UserControl.TextWidth(Z)
    If W > TW Then TW = W
    If W > MaxW Then MaxW = W
    S = Z: X = X1
    Select Case prpAlignmentH
      Case p3dTextAlignmentHorz.p3dNoAlignH
      Case p3dTextAlignmentHorz.p3dAlignLeft
        X = X1
      Case p3dTextAlignmentHorz.p3dAlignCenter
        X = (X1 + X2 - W) / 2
      Case p3dTextAlignmentHorz.p3dAlignRight
        X = X2 - W
      'Case p3dTextAlignmentHorz.p3dAlignJustify
      'Case p3dTextAlignmentHorz.p3dAlignFullH
    End Select
    X = Fix(0.5 + UserControl.ScaleX(X, UserControl.ScaleMode, vbPixels))
      X = UserControl.ScaleX(X, vbPixels, UserControl.ScaleMode)
    Y = Fix(0.5 + UserControl.ScaleY(Y, UserControl.ScaleMode, vbPixels))
      Y = UserControl.ScaleY(Y, vbPixels, UserControl.ScaleMode)
    Select Case prpFont3D
      Case p3dFont3DFX.p3dInsetHard
        UserControl.ForeColor = prpColor3DLight
          UserControl.CurrentX = X + PX: UserControl.CurrentY = Y + PY
          UserControl.Print S
        UserControl.ForeColor = prpColor3DShadow
          UserControl.CurrentX = X: UserControl.CurrentY = Y
          UserControl.Print S
      Case p3dFont3DFX.p3dInsetLight
        UserControl.ForeColor = prpColor3DLight
          UserControl.CurrentX = X + PX: UserControl.CurrentY = Y + PY
          UserControl.Print S
        UserControl.ForeColor = prpForeColor
          UserControl.CurrentX = X: UserControl.CurrentY = Y
          UserControl.Print S
      Case p3dFont3DFX.p3dNo3D
        UserControl.ForeColor = prpForeColor
          UserControl.CurrentX = X: UserControl.CurrentY = Y
          UserControl.Print S
      Case p3dFont3DFX.p3dRaisedLight
        UserControl.ForeColor = prpColor3DLight
          UserControl.CurrentX = X - PX: UserControl.CurrentY = Y - PY
          UserControl.Print S
        UserControl.ForeColor = prpForeColor
          UserControl.CurrentX = X: UserControl.CurrentY = Y
          UserControl.Print S
      Case p3dFont3DFX.p3dRaisedHard
        UserControl.ForeColor = prpColor3DLight
          UserControl.CurrentX = X - PX: UserControl.CurrentY = Y - PY
          UserControl.Print S
        UserControl.ForeColor = prpColor3DShadow
          UserControl.CurrentX = X: UserControl.CurrentY = Y
          UserControl.Print S
    End Select
    Y = Y + DY * UserControl.TextHeight(S)
  Next I
  Y2 = UserControl.CurrentY 'TextBox Y2
  UserControl.ForeColor = prpForeColor
End If
If Len(Z) = 0 Then
  H = UserControl.TextHeight("")
  Select Case prpAlignmentV
    Case p3dTextAlignmentVert.p3dNoAlignV
    Case p3dTextAlignmentVert.p3dAlignTop
    Case p3dTextAlignmentVert.p3dAlignMiddle
      Y1 = (Y1 + Y2 - H) / 2
    Case p3dTextAlignmentVert.p3dAlignBottom
      Y1 = Y2 - H
    Case p3dTextAlignmentVert.p3dAlignFullV
      H = Y2 - Y1
  End Select
  Y2 = Y1 + H
End If
X1 = Fix(X1 + prpFieldE + 0.5): X2 = Fix(X2 - prpFieldE + 0.5)
Y1 = Fix(Y1 + prpFieldV + 0.5): Y2 = Fix(Y2 - prpFieldV + 0.5)
If Y1 > Y2 Then Y1 = Fix((Y1 + Y2) / 2 + 0.5): Y2 = Y1
If X1 > X2 Then X1 = Fix((X1 + X2) / 2 + 0.5): X2 = X1
Y = Y1: X = Fix((X1 + X2) / 2 + 0.5)
H = Y2 - Y1: W = MaxW
'UserControl.Line (X1, Y1)-(X2, Y2), , B
Select Case prpTitleBar
  Case p3dTitleBarStyle.p3dNone
  Case p3dTitleBarStyle.p3dVertLines
    If prpUse3DLine Then I = 4 Else I = 2
    For Y = Y1 To Y2 Step I
      If prpUse3DLine Then
        Line (X1, Y)-(X - W / 2 - prpFieldI, Y), prpColor3DLight
        Line (X + W / 2 + prpFieldI, Y)-(X2, Y), prpColor3DLight
        Line (X1, Y + 1)-(X - W / 2 - prpFieldI, Y + 1), prpColor3DShadow
        Line (X + W / 2 + prpFieldI, Y + 1)-(X2, Y + 1), prpColor3DShadow
      Else
        Line (X1, Y)-(X - W / 2 - prpFieldI, Y), prpForeColor
        Line (X + W / 2 + prpFieldI, Y)-(X2, Y), prpForeColor
      End If
    Next Y
  Case p3dTitleBarStyle.p3dHorzLines
    I = 4
    For X = 0 To Fix((X1 + X2) / 2) Step I
      If X + prpFieldI < ((X2 - X1) - W) / 2 Then
        If prpUse3DLine Then
          Line (X1 + X, Y1)-(X1 + X, Y2), prpColor3DLight
          Line (X1 + X + 1, Y1)-(X1 + X + 1, Y2), prpColor3DShadow
          Line (X2 - X, Y1)-(X2 - X, Y2), prpColor3DLight
          Line (X2 - X + 1, Y1)-(X2 - X + 1, Y2), prpColor3DShadow
        Else
          Line (X1 + X, Y1)-(X1 + X, Y2), prpForeColor
          Line (X2 - X, Y1)-(X2 - X, Y2), prpForeColor
        End If
      End If
    Next X
  Case p3dTitleBarStyle.p3dInsideLines
    I = 4
    For X = 0 To Fix((X1 + X2) / 2) Step I
      If X + prpFieldI + H < ((X2 - X1) - W) / 2 Then
        If prpUse3DLine Then
          Line (X1 + X, Y)-(X1 + X + H, Y + H), prpColor3DLight
          Line (X1 + X + 1, Y)-(X1 + X + H + 1, Y + H), prpColor3DShadow
          Line (X2 - X, Y)-(X2 - X - H, Y + H), prpColor3DLight
          Line (X2 - X - 1, Y)-(X2 - X - H - 1, Y + H), prpColor3DShadow
        Else
          Line (X1 + X, Y)-(X1 + X + H, Y + H), prpForeColor
          Line (X2 - X, Y)-(X2 - X - H, Y + H), prpForeColor
        End If
      End If
    Next X
  Case p3dTitleBarStyle.p3dOutsideLines
    I = 4
    For X = 0 To Fix((X1 + X2) / 2) Step I
      If X + prpFieldI + H < ((X2 - X1) - W) / 2 Then
        If prpUse3DLine Then
          Line (X1 + X + H, Y)-(X1 + X, Y + H), prpColor3DLight
          Line (X1 + X + H + 1, Y)-(X1 + X + 1, Y + H), prpColor3DShadow
          Line (X2 - X - H, Y)-(X2 - X, Y + H), prpColor3DLight
          Line (X2 - X - H - 1, Y)-(X2 - X - 1, Y + H), prpColor3DShadow
        Else
          Line (X1 + X + H, Y)-(X1 + X, Y + H), prpForeColor
          Line (X2 - X - H, Y)-(X2 - X, Y + H), prpForeColor
        End If
      End If
    Next X
End Select
UserControl.ForeColor = prpForeColor
End Sub
'END User subs

Private Function Delimit(No As Integer, DataString As Variant, Delimiter As String) As Variant
Dim V As Variant, N As Integer, I As Integer, I0 As Integer
If Len(DataString) = 0 Then
  If No = 0 Then
      V = 0
    Else
      V = ""
  End If
  Delimit = V
  Exit Function
End If
I0 = 1
If No = 0 Then
  N = 1
  Do
    I = InStr(I0, DataString, Delimiter)
    If I = 0 Then Exit Do
    N = N + 1
    I0 = I + Len(Delimiter)
  Loop
  Delimit = N
  Exit Function
End If
I0 = 1
N = 1
Do
  I = InStr(I0, DataString, Delimiter)
  If I = 0 Then Exit Do
  If N = No Then Exit Do
  N = N + 1
  I0 = I + Len(Delimiter)
Loop
If N < No Then
  Delimit = ""
  Exit Function
End If
I = InStr(I0, DataString, Delimiter)
If I = 0 Then
    V = Mid$(DataString, I0)
  Else
    V = Mid$(DataString, I0, I - I0)
End If
Delimit = V
End Function

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,Controls
Public Property Get Controls() As Object
Attribute Controls.VB_Description = "A collection whose elements represent each control on a form, including elements of control arrays. "
  Set Controls = UserControl.Controls
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,Font
Public Property Get Font() As Font
Attribute Font.VB_Description = "Returns a Font object."
Attribute Font.VB_ProcData.VB_Invoke_Property = ";Font"
Attribute Font.VB_UserMemId = -512
  Set Font = UserControl.Font
End Property

Public Property Set Font(ByVal New_Font As Font)
  Set UserControl.Font = New_Font
  PropertyChanged "Font"
  Paint_Me '*Refresh control*
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,hDC
Public Property Get hDC() As Long
Attribute hDC.VB_Description = "Returns a handle (from Microsoft Windows) to the object's device context."
  hDC = UserControl.hDC
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,hWnd
Public Property Get hWnd() As Long
Attribute hWnd.VB_Description = "Returns a handle (from Microsoft Windows) to an object's window."
  hWnd = UserControl.hWnd
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,BackColor
Public Property Get BackColor() As OLE_COLOR
Attribute BackColor.VB_Description = "Returns/Sets background color."
Attribute BackColor.VB_ProcData.VB_Invoke_Property = ";Appearance"
  BackColor = UserControl.BackColor
End Property

Public Property Let BackColor(ByVal New_BackColor As OLE_COLOR)
  UserControl.BackColor() = New_BackColor
  PropertyChanged "BackColor"
  Paint_Me '*Refresh control*
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,ForeColor
Public Property Get ForeColor() As OLE_COLOR
Attribute ForeColor.VB_Description = "Returns/sets the foreground color used to display text and graphics in an object."
Attribute ForeColor.VB_ProcData.VB_Invoke_Property = ";Appearance"
  ForeColor = prpForeColor
End Property

Public Property Let ForeColor(ByVal New_ForeColor As OLE_COLOR)
  prpForeColor = New_ForeColor
  PropertyChanged "ForeColor"
  Paint_Me '*Refresh control*
End Property

Private Sub UserControl_Paint()
  Paint_Me '*Refresh control*
End Sub

Private Sub UserControl_Resize()
Dim S As Single
S = UserControl.Width / Screen.TwipsPerPixelX
If UserControl.Height / Screen.TwipsPerPixelY < S Then S = UserControl.Height / Screen.TwipsPerPixelY
S = Fix(S / 2)
If prpRound > S Then
  prpRound = S
  PropertyChanged "Round"
End If
Paint_Me '*Refresh control*
End Sub

Private Sub UserControl_Show()
Paint_Me '*Refresh control*
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
  Call PropBag.WriteProperty("Font", Font, Ambient.Font)
  Call PropBag.WriteProperty("BackColor", UserControl.BackColor, vb3DFace)
  Call PropBag.WriteProperty("ForeColor", prpForeColor, vbButtonText)
  Call PropBag.WriteProperty("Enabled", UserControl.Enabled, True)
  Call PropBag.WriteProperty("MouseIcon", MouseIcon, Nothing)
  Call PropBag.WriteProperty("MousePointer", UserControl.MousePointer, 0)
  Call PropBag.WriteProperty("AutoColor3D", prpAutoColor3D, True)
  Call PropBag.WriteProperty("Color3DFace", prpColor3DFace, p3dColor3DFace)
  Call PropBag.WriteProperty("Color3DShadow", prpColor3DShadow, p3dColor3DShadow)
  Call PropBag.WriteProperty("Color3DLight", prpColor3DLight, p3dColor3DLight)
  Call PropBag.WriteProperty("Outline", prpOutline, p3dOutline)
  Call PropBag.WriteProperty("Round", prpRound, p3dRound)
  Call PropBag.WriteProperty("BevelInner", prpBevelInner, p3dBevelInner)
  Call PropBag.WriteProperty("BevelOuter", prpBevelOuter, p3dBevelOuter)
  Call PropBag.WriteProperty("BevelWidth", prpBevelWidth, p3dBevelWidth)
  Call PropBag.WriteProperty("BorderWidth", prpBorderWidth, p3dBorderWidth)
  Call PropBag.WriteProperty("TitleBar", prpTitleBar, p3dTitleBar)
  Call PropBag.WriteProperty("TitleBar3D", prpUse3DLine, p3dUse3DLine)
  Call PropBag.WriteProperty("TitleFieldVert", prpFieldV, p3dFieldV)
  Call PropBag.WriteProperty("TitleFieldExt", prpFieldE, p3dFieldE)
  Call PropBag.WriteProperty("TitleFieldInt", prpFieldI, p3dFieldI)
  Call PropBag.WriteProperty("Text", prpText, p3dText)
  Call PropBag.WriteProperty("WordWrap", prpWordWrap, p3dWordWrap)
  Call PropBag.WriteProperty("AlignmentH", prpAlignmentH, p3dAlignmentH)
  Call PropBag.WriteProperty("AlignmentV", prpAlignmentV, p3dAlignmentV)
  Call PropBag.WriteProperty("Font3D", prpFont3D, p3dFont3D)
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
  Set Font = PropBag.ReadProperty("Font", Ambient.Font)
  UserControl.BackColor = PropBag.ReadProperty("BackColor", vb3DFace)
  prpForeColor = PropBag.ReadProperty("ForeColor", vbButtonText)
  UserControl.Enabled = PropBag.ReadProperty("Enabled", True)
  Set MouseIcon = PropBag.ReadProperty("MouseIcon", Nothing)
  UserControl.MousePointer = PropBag.ReadProperty("MousePointer", 0)
  prpAutoColor3D = PropBag.ReadProperty("AutoColor3D", True)
  prpColor3DFace = PropBag.ReadProperty("Color3DFace", p3dColor3DFace)
  prpColor3DShadow = PropBag.ReadProperty("Color3DShadow", p3dColor3DShadow)
  prpColor3DLight = PropBag.ReadProperty("Color3DLight", p3dColor3DLight)
  prpOutline = PropBag.ReadProperty("Outline", p3dOutline)
  prpRound = PropBag.ReadProperty("Round", p3dRound)
  prpBevelInner = PropBag.ReadProperty("BevelInner", p3dBevelInner)
  prpBevelOuter = PropBag.ReadProperty("BevelOuter", p3dBevelOuter)
  prpBevelWidth = PropBag.ReadProperty("BevelWidth", p3dBevelWidth)
  prpBorderWidth = PropBag.ReadProperty("BorderWidth", p3dBorderWidth)
  prpTitleBar = PropBag.ReadProperty("TitleBar", p3dTitleBar)
  prpUse3DLine = PropBag.ReadProperty("TitleBar3D", p3dUse3DLine)
  prpFieldV = PropBag.ReadProperty("TitleFieldVert", p3dFieldV)
  prpFieldE = PropBag.ReadProperty("TitleFieldExt", p3dFieldE)
  prpFieldI = PropBag.ReadProperty("TitleFieldInt", p3dFieldI)
  prpText = PropBag.ReadProperty("Text", p3dText)
  prpWordWrap = PropBag.ReadProperty("WordWrap", p3dWordWrap)
  prpAlignmentH = PropBag.ReadProperty("AlignmentH", p3dAlignmentH)
  prpAlignmentV = PropBag.ReadProperty("AlignmentV", p3dAlignmentV)
  prpFont3D = PropBag.ReadProperty("Font3D", p3dFont3D)
End Sub

Private Sub UserControl_Click()
  RaiseEvent Click
End Sub

Private Sub UserControl_DblClick()
  RaiseEvent DblClick
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,Enabled
Public Property Get Enabled() As Boolean
Attribute Enabled.VB_Description = "Returns/sets a value that determines whether an object can respond to user-generated events."
Attribute Enabled.VB_ProcData.VB_Invoke_Property = ";Behavior"
  Enabled = UserControl.Enabled
End Property

Public Property Let Enabled(ByVal New_Enabled As Boolean)
  UserControl.Enabled() = New_Enabled
  PropertyChanged "Enabled"
End Property

Private Sub UserControl_InitProperties()
  Set Font = Ambient.Font
  prpAutoColor3D = True
  prpForeColor = UserControl.ForeColor
  prpColor3DFace = p3dColor3DFace
  prpColor3DShadow = p3dColor3DShadow
  prpColor3DLight = p3dColor3DLight
  prpOutline = p3dOutline
  prpRound = p3dRound
  prpBevelInner = p3dBevelInner
  prpBevelOuter = p3dBevelOuter
  prpTitleBar = p3dTitleBar
  prpUse3DLine = p3dUse3DLine
  prpFieldV = p3dFieldV
  prpFieldE = p3dFieldE
  prpFieldI = p3dFieldI
  prpText = p3dText
  prpWordWrap = p3dWordWrap
  prpAlignmentH = p3dAlignmentH
  prpAlignmentV = p3dAlignmentV
  prpFont3D = p3dFont3D
  prpBevelWidth = p3dBevelWidth
  prpBorderWidth = p3dBorderWidth
  Busy = False
End Sub

Private Sub UserControl_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
  RaiseEvent MouseDown(Button, Shift, X, Y)
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,MouseIcon
Public Property Get MouseIcon() As Picture
Attribute MouseIcon.VB_Description = "Sets a custom mouse icon."
  Set MouseIcon = UserControl.MouseIcon
End Property

Public Property Set MouseIcon(ByVal New_MouseIcon As Picture)
  Set UserControl.MouseIcon = New_MouseIcon
  PropertyChanged "MouseIcon"
End Property

Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
  RaiseEvent MouseMove(Button, Shift, X, Y)
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,MousePointer
Public Property Get MousePointer() As MousePointerConstants
Attribute MousePointer.VB_Description = "Returns/sets the type of mouse pointer displayed when over part of an object."
  MousePointer = UserControl.MousePointer
End Property

Public Property Let MousePointer(ByVal New_MousePointer As MousePointerConstants)
  UserControl.MousePointer() = New_MousePointer
  PropertyChanged "MousePointer"
End Property

Private Sub UserControl_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
  RaiseEvent MouseUp(Button, Shift, X, Y)
End Sub

Public Property Get AutoColor3D() As Boolean
Attribute AutoColor3D.VB_Description = "Returns/Sets state automatic color change. When True, changed 'BackColor', 'Color3DLight' and 'Color3DShadow' properties on change property 'Color3DFace'."
Attribute AutoColor3D.VB_ProcData.VB_Invoke_Property = ";Appearance"
  AutoColor3D = prpAutoColor3D
End Property

Public Property Let AutoColor3D(ByVal New_AutoColor3D As Boolean)
  prpAutoColor3D = New_AutoColor3D
  PropertyChanged "AutoColor3D"
End Property

Public Property Get Color3DFace() As OLE_COLOR
  Color3DFace = prpColor3DFace
End Property

Public Property Let Color3DFace(ByVal New_Color3DFace As OLE_COLOR)
Attribute Color3DFace.VB_Description = "Returns/Sets face color (border color)."
Attribute Color3DFace.VB_ProcData.VB_Invoke_PropertyPut = ";Appearance"
Dim Z As String, R As Integer, G As Integer, B As Integer
Dim RL As Integer, GL As Integer, BL As Integer
Dim RS As Integer, GS As Integer, BS As Integer
  prpColor3DFace = New_Color3DFace
  PropertyChanged "Color3DFace"
  Busy = True
  If prpAutoColor3D Then
    UserControl.BackColor = prpColor3DFace
    Select Case prpColor3DFace
      Case vb3DFace
        prpColor3DLight = vb3DHighlight
        prpColor3DShadow = vb3DShadow
      Case &HC0C0C0
        prpColor3DLight = &HFFFFFF
        prpColor3DShadow = &H808080
      Case Else
        Z = Hex$(prpColor3DFace): If Len(Z) < 6 Then Z = String$(6 - Len(Z), "0") + Z
        R = Val("&h" & Left$(Right$(Z, 2), 2))
        G = Val("&h" & Left$(Right$(Z, 4), 2))
        B = Val("&h" & Left$(Right$(Z, 6), 2))
        If Len(Z) > 6 Then Z = Left$(Z, Len(Z) - 6) Else Z = "0"
        If Len(Z) < 2 Then Z = String$(2 - Len(Z), "0")
        If Val("&h" & Z) <> 0 Then
          Exit Property
        End If
        RL = R + &H40: RS = R - &H40
          If RL < 0 Then RL = 0
          If RL > &HFF Then RL = &HFF
          If RS < 0 Then RS = 0
          If RS > &HFF Then RS = &HFF
        GL = G + &H40: GS = G - &H40
          If GL < 0 Then GL = 0
          If GL > &HFF Then GL = &HFF
          If GS < 0 Then GS = 0
          If GS > &HFF Then GS = &HFF
        BL = B + &H40: BS = B - &H40
          If BL < 0 Then BL = 0
          If BL > &HFF Then BL = &HFF
          If BS < 0 Then BS = 0
          If BS > &HFF Then BS = &HFF
        prpColor3DLight = RGB(RL, GL, BL)
        PropertyChanged "Color3DLight"
        prpColor3DShadow = RGB(RS, GS, BS)
        PropertyChanged "Color3DShadow"
    End Select
  End If
  Busy = False
  Paint_Me '*Refresh control*
End Property

Public Property Get Color3DShadow() As OLE_COLOR
Attribute Color3DShadow.VB_Description = "Returns/Sets shadow edge color."
Attribute Color3DShadow.VB_ProcData.VB_Invoke_Property = ";Appearance"
  Color3DShadow = prpColor3DShadow
End Property

Public Property Let Color3DShadow(ByVal New_Color3DShadow As OLE_COLOR)
  prpColor3DShadow = New_Color3DShadow
  PropertyChanged "Color3DShadow"
  Paint_Me '*Refresh control*
End Property

Public Property Get Color3DLight() As OLE_COLOR
Attribute Color3DLight.VB_Description = "Returns/Sets light edge color."
Attribute Color3DLight.VB_ProcData.VB_Invoke_Property = ";Appearance"
  Color3DLight = prpColor3DLight
End Property

Public Property Let Color3DLight(ByVal New_Color3DLight As OLE_COLOR)
  prpColor3DLight = New_Color3DLight
  PropertyChanged "Color3DLight"
  Paint_Me '*Refresh control*
End Property

Public Property Get Outline() As Boolean
Attribute Outline.VB_Description = "Returns/Sets outline. When True, control stroked 1-pixel line (used WindowFrame color)."
Attribute Outline.VB_ProcData.VB_Invoke_Property = ";Appearance"
  Outline = prpOutline
End Property

Public Property Let Outline(ByVal New_Outline As Boolean)
  prpOutline = New_Outline
  PropertyChanged "Outline"
  Paint_Me '*Refresh control*
End Property

Public Property Get Round() As Integer
Attribute Round.VB_Description = "Returns/Sets corner round radius (in pixels). For rectangle corners enter 'Round' = 0."
Attribute Round.VB_ProcData.VB_Invoke_Property = ";Appearance"
  Round = prpRound
End Property

Public Property Let Round(ByVal New_Round As Integer)
Dim S As Single
Busy = True
S = UserControl.Width / Screen.TwipsPerPixelX
If UserControl.Height / Screen.TwipsPerPixelY < S Then S = UserControl.Height / Screen.TwipsPerPixelY
S = Fix(S / 2)
  Select Case New_Round
    Case Is < 0
      MsgBox "The 'Round' properties must been =>0 and <Width/2", vbExclamation, ErrMsg
    Case 0 To S
      prpRound = New_Round
      PropertyChanged "Round"
    Case Else
      MsgBox "The 'Round' properties too long (must been =>0 and <Width/2)", vbExclamation, ErrMsg
      New_Round = S
      prpRound = New_Round
      PropertyChanged "Round"
  End Select
Busy = False
Paint_Me '*Refresh control*
End Property

Public Property Get BevelInner() As p3dBevelType
Attribute BevelInner.VB_Description = "Returns/Sets internal bevel (BevelInner) type."
Attribute BevelInner.VB_ProcData.VB_Invoke_Property = ";Appearance"
  BevelInner = prpBevelInner
End Property

Public Property Let BevelInner(ByVal New_BevelInner As p3dBevelType)
  Select Case New_BevelInner
    Case p3dBevelType.p3dNoBevel, p3dBevelType.p3dFixedLight, p3dBevelType.p3dFixedShadow, p3dBevelType.p3dInset, p3dBevelType.p3dRaised
      prpBevelInner = New_BevelInner
      PropertyChanged "BevelInner"
      Paint_Me '*Refresh control*
    Case Else
      MsgBox "Unknown BevelInner bevel type!", vbExclamation, ErrMsg
  End Select
End Property

Public Property Get BevelOuter() As p3dBevelType
Attribute BevelOuter.VB_Description = "Returns/Sets external bevel (BevelOuter) type."
Attribute BevelOuter.VB_ProcData.VB_Invoke_Property = ";Appearance"
  BevelOuter = prpBevelOuter
End Property

Public Property Let BevelOuter(ByVal New_BevelOuter As p3dBevelType)
  Select Case New_BevelOuter
    Case p3dBevelType.p3dNoBevel, p3dBevelType.p3dFixedLight, p3dBevelType.p3dFixedShadow, p3dBevelType.p3dInset, p3dBevelType.p3dRaised
      prpBevelOuter = New_BevelOuter
      PropertyChanged "BevelOuter"
      Paint_Me '*Refresh control*
    Case Else
      MsgBox "Unknown BevelOuter bevel type!", vbExclamation, ErrMsg
  End Select
End Property

Public Property Get TitleBar() As p3dTitleBarStyle
Attribute TitleBar.VB_Description = "Returns/Sets Title Bar Style. Title Bar locate in to Text alignment (vert. and horz.)."
Attribute TitleBar.VB_ProcData.VB_Invoke_Property = ";Appearance"
  TitleBar = prpTitleBar
End Property

Public Property Let TitleBar(ByVal New_TitleBar As p3dTitleBarStyle)
  Select Case New_TitleBar
    Case p3dTitleBarStyle.p3dNone, p3dTitleBarStyle.p3dVertLines, p3dTitleBarStyle.p3dHorzLines, p3dTitleBarStyle.p3dInsideLines, p3dTitleBarStyle.p3dOutsideLines
      prpTitleBar = New_TitleBar
      PropertyChanged "TitleBar"
      Paint_Me '*Refresh control*
    Case Else
      MsgBox "Unknown BevelOuter bevel type!", vbExclamation, ErrMsg
  End Select
End Property

Public Property Get TitleBar3D() As Boolean
Attribute TitleBar3D.VB_Description = "Returns/Sets style of the Title Bar Lines (3D or flat)."
Attribute TitleBar3D.VB_ProcData.VB_Invoke_Property = ";Appearance"
  TitleBar3D = prpUse3DLine
End Property

Public Property Let TitleBar3D(ByVal New_TitleBar3D As Boolean)
  prpUse3DLine = New_TitleBar3D
  PropertyChanged "TitleBar3D"
  Paint_Me '*Refresh control*
End Property

Public Property Get TitleFieldVert() As Integer
Attribute TitleFieldVert.VB_Description = "Returns/Sets vertical fields for TitleBar (top and bottom border)."
Attribute TitleFieldVert.VB_ProcData.VB_Invoke_Property = ";Appearance"
  TitleFieldVert = prpFieldV
End Property

Public Property Let TitleFieldVert(ByVal New_TitleFieldVert As Integer)
  Select Case New_TitleFieldVert
    Case Is < 0
      MsgBox "The 'TitleFieldVert' properties must been =>0 and <100", vbExclamation, ErrMsg
    Case 0 To 99
      prpFieldV = New_TitleFieldVert
      PropertyChanged "TitleFieldVert"
      Paint_Me '*Refresh control*
    Case Else
      MsgBox "The 'TitleFieldVert' properties too long (must been =>0 and <100)", vbExclamation, ErrMsg
  End Select
End Property

Public Property Get TitleFieldExt() As Integer
Attribute TitleFieldExt.VB_Description = "Returns/Sets external fields for TitleBar (outer border)."
Attribute TitleFieldExt.VB_ProcData.VB_Invoke_Property = ";Appearance"
  TitleFieldExt = prpFieldE
End Property

Public Property Let TitleFieldExt(ByVal New_TitleFieldExt As Integer)
  Select Case New_TitleFieldExt
    Case Is < 0
      MsgBox "The 'TitleFieldExt' properties must been =>0 and <32", vbExclamation, ErrMsg
    Case 0 To 31
      prpFieldE = New_TitleFieldExt
      PropertyChanged "TitleFieldExt"
      Paint_Me '*Refresh control*
    Case Else
      MsgBox "The 'TitleFieldExt' properties too long (must been =>0 and <32)", vbExclamation, ErrMsg
  End Select
End Property

Public Property Get TitleFieldInt() As Integer
Attribute TitleFieldInt.VB_Description = "Returns/Sets internal fields for TitleBar (inner border)."
Attribute TitleFieldInt.VB_ProcData.VB_Invoke_Property = ";Appearance"
  TitleFieldInt = prpFieldI
End Property

Public Property Let TitleFieldInt(ByVal New_TitleFieldInt As Integer)
  Select Case New_TitleFieldInt
    Case Is < 0
      MsgBox "The 'TitleFieldInt' properties must been =>0 and <32", vbExclamation, ErrMsg
    Case 0 To 31
      prpFieldI = New_TitleFieldInt
      PropertyChanged "TitleFieldInt"
      Paint_Me '*Refresh control*
    Case Else
      MsgBox "The 'TitleFieldInt' properties too long (must been =>0 and <32)", vbExclamation, ErrMsg
  End Select
End Property

Public Property Get Text() As Variant
Attribute Text.VB_Description = "Returns/Sets text, which displaying on panel."
Attribute Text.VB_ProcData.VB_Invoke_Property = ";Text"
Attribute Text.VB_UserMemId = 0
  Text = prpText
End Property

Public Property Let Text(ByVal New_Text As Variant)
  prpText = New_Text
  PropertyChanged "Text"
  Paint_Me '*Refresh control*
End Property

Public Property Get WordWrap() As p3dWordWrapStyle
Attribute WordWrap.VB_Description = "Returns/Sets WordWrap style. Applied to 'Text'."
Attribute WordWrap.VB_ProcData.VB_Invoke_Property = ";Text"
  WordWrap = prpWordWrap
End Property

Public Property Let WordWrap(ByVal New_WordWrap As p3dWordWrapStyle)
  Select Case New_WordWrap
    Case p3dWordWrapStyle.p3dNoWrap, p3dWordWrapStyle.p3dNormalWrap, p3dWordWrapStyle.p3dForceWrap
      prpWordWrap = New_WordWrap
      PropertyChanged "WordWrap"
      Paint_Me '*Refresh control*
    Case Else
      MsgBox "Unknown 'WordWrap' type!", vbExclamation, ErrMsg
  End Select
End Property

Public Property Get AlignmentH() As p3dTextAlignmentHorz
Attribute AlignmentH.VB_Description = "Returns/Sets horizontal alignment. Applied to 'Text'."
Attribute AlignmentH.VB_ProcData.VB_Invoke_Property = ";Text"
  AlignmentH = prpAlignmentH
End Property

Public Property Let AlignmentH(ByVal New_AlignmentH As p3dTextAlignmentHorz)
  Select Case New_AlignmentH
    Case p3dTextAlignmentHorz.p3dNoAlignH, p3dTextAlignmentHorz.p3dAlignLeft, p3dTextAlignmentHorz.p3dAlignCenter, p3dTextAlignmentHorz.p3dAlignRight, p3dTextAlignmentHorz.p3dAlignJustify, p3dTextAlignmentHorz.p3dAlignFullH
      prpAlignmentH = New_AlignmentH
      PropertyChanged "AlignmentH"
      Paint_Me '*Refresh control*
    Case Else
      MsgBox "Unknown horizontal alignment!", vbExclamation, ErrMsg
  End Select
End Property

Public Property Get AlignmentV() As p3dTextAlignmentVert
Attribute AlignmentV.VB_Description = "Returns/Sets vertical alignment. Applied to 'Text'."
Attribute AlignmentV.VB_ProcData.VB_Invoke_Property = ";Text"
  AlignmentV = prpAlignmentV
End Property

Public Property Let AlignmentV(ByVal New_AlignmentV As p3dTextAlignmentVert)
  Select Case New_AlignmentV
    Case p3dTextAlignmentVert.p3dNoAlignV, p3dTextAlignmentVert.p3dAlignTop, p3dTextAlignmentVert.p3dAlignMiddle, p3dTextAlignmentVert.p3dAlignBottom, p3dTextAlignmentVert.p3dAlignFullV
      prpAlignmentV = New_AlignmentV
      PropertyChanged "AlignmentV"
      Paint_Me '*Refresh control*
    Case Else
      MsgBox "Unknown vertical alignment!", vbExclamation, ErrMsg
  End Select
End Property

Public Property Get Font3D() As p3dFont3DFX
Attribute Font3D.VB_Description = "Returns/Sets 3Dfx for text. Applied to 'Text'."
Attribute Font3D.VB_ProcData.VB_Invoke_Property = ";Appearance"
  Font3D = prpFont3D
End Property

Public Property Let Font3D(ByVal New_Font3D As p3dFont3DFX)
  Select Case New_Font3D
    Case p3dFont3DFX.p3dNo3D, p3dFont3DFX.p3dInsetHard, p3dFont3DFX.p3dInsetLight, p3dFont3DFX.p3dRaisedLight, p3dFont3DFX.p3dRaisedHard
      prpFont3D = New_Font3D
      PropertyChanged "Font3D"
      Paint_Me '*Refresh control*
    Case Else
      MsgBox "Unknown 3DFX!", vbExclamation, ErrMsg
  End Select
End Property

Public Property Get BevelWidth() As Integer
Attribute BevelWidth.VB_Description = "Returns/Sets bevel width (in pixels). Diapasone: 0...31 (0 - no bevel)."
Attribute BevelWidth.VB_ProcData.VB_Invoke_Property = ";Appearance"
  BevelWidth = prpBevelWidth
End Property

Public Property Let BevelWidth(ByVal New_BevelWidth As Integer)
  Select Case New_BevelWidth
    Case Is < 0
      MsgBox "The 'BevelWidth' properties must been =>0 and <32", vbExclamation, ErrMsg
    Case 0 To 31
      prpBevelWidth = New_BevelWidth
      PropertyChanged "BevelWidth"
      Paint_Me '*Refresh control*
    Case Else
      MsgBox "The 'BevelWidth' properties too long (must been =>0 and <32)", vbExclamation, ErrMsg
  End Select
End Property

Public Property Get BorderWidth() As Integer
Attribute BorderWidth.VB_Description = "Returns/Sets border width (in pixels). Diapasone: 0...31 (0 - no border)."
Attribute BorderWidth.VB_ProcData.VB_Invoke_Property = ";Appearance"
  BorderWidth = prpBorderWidth
End Property

Public Property Let BorderWidth(ByVal New_BorderWidth As Integer)
  Select Case New_BorderWidth
    Case Is < 0
      MsgBox "The 'BorderWidth' properties must been =>0 and <32", vbExclamation, ErrMsg
    Case 0 To 31
      prpBorderWidth = New_BorderWidth
      PropertyChanged "BorderWidth"
      Paint_Me '*Refresh control*
    Case Else
      MsgBox "The 'BorderWidth' properties too long (must been =>0 and <32)", vbExclamation, ErrMsg
  End Select
End Property
